Pixel = Struct.new(:r, :g, :b)
$img = Array.new(200) do
  Array.new(300) do Pixel.new(255,255,255) end
end
def pset(x, y, r, g, b, t)
  if 0 <= x && x < 300 && 0 <= y && y < 200
	$img[y][x].r = (r*t+(1.0-t)*$img[y][x].r).to_i 
	$img[y][x].g = (g*t+(1.0-t)*$img[y][x].g).to_i
	$img[y][x].b = (b*t+(1.0-t)*$img[y][x].b).to_i
  end
end
def writeimage(name)
  open(name, "wb") do |f|
    f.puts("P6\n300 200\n255")
    $img.each do |a|
      a.each do |p| f.write(p.to_a.pack("ccc")) end
    end
  end
end

##############
#この先　演習2#
##############

def fillcircle (x0, y0, rad, r, g, b, t)
  200.times do |y|
    300.times do |x|
      if (x-x0)**2 + (y-y0)**2 <= rad **2
        pset(x, y, r, g, b, t)
      end
    end
  end
end
def fillsikaku (x,y,length,r,g,b,t)  
  x.step(x + length) do |n|
    y.step(y + length) do |m|
    pset(n,m,r,g,b,t)
    end
  end
end
def fillchouhou (x,y,lengthx,lengthy,r,g,b,t)
  x.step(x + lengthx) do |n|
    y.step(y + lengthy) do |m|
    pset(n,m,r,g,b,t)
    end
  end
end
def tesuya
  200.times do |y|
    300.times do |x|
        pset(x, y, 0,0 ,((x-150).abs + (y-100).abs) / 2,0)
    end
  end
    writeimage("tesuya.ppm")
end

def fillcircle (x0, y0, rad1, rad2, r, g, b,t)
  200.times do |y|
    300.times do |x|
      if (x-x0)**2 + (y-y0)**2 <= rad**2 && x**2 +y**2 >= rad**2
        pset(x, y, r, g, b,t)
      end
    end
  end
end

def fillsankaku(x,y,r,g,b,t)#6つもの入力を用意すると面倒だから配列で入力してください
  3.times do |k|
    x[k-1] = x[k-1].to_f ;y[k-1] = y[k-1].to_f
  end
  if x[0] <= x[1] && x[0] < x[2]
    ax = x[0];ay = y[0]
    if x[1] < x[2]
      bx = x[1];by = y[1];cx = x[2];cy = y[2]
    else
      bx = x[2];by = y[2];cx = x[1];cy = y[1]
    end
  elsif x[1] <= x[2] && x[1] < x[0]
    ax = x[1];ay = y[1]
    if x[0] < x[2]
      bx = x[0];by = y[0];cx = x[2];cy = y[2]
    else
      bx = x[2];by = y[2];cx = x[0];cy = y[0]
    end
  elsif x[2] <= x[0] && x[2] < x[1]
    ax = x[2];ay = y[2]
    if x[0] < x[1]
      bx = x[0];by = y[0];cx = x[1];cy = y[1]
    else
      bx = x[1];by = y[1];cx = x[0];cy = y[0]
    end

    k1 = (by - ay)/(bx - ax)


    k2 = (cy - by)/(cx - bx)

    k3 = (cy - ay)/(cx - ax)
  if k1 == k2 ||　k2 == k3 || k3 == k1 #2辺が平行なら三角形にはならないはずである
    print "いやそれ三角形にならなくねぇ？"
  end
  #k1はa-b、k2はb-c、k3はa-cに相当    この下から描画部分
  axi = ax.to_i;bxi =bx.to_i;cxi = cx.to_i
  if ay < by

      axi.step(bxi-1) do |xi|
        200.times do |yi|
          if k1 * (xi - ax) + ay >= yi && k3 * (xi-ax) + ay <= yi
          pset(xi,yi,r,g,b,t)
          end
        end

    end

      bxi.step(cxi) do |xj|
        200.times do |yj|
          if k2 * (xj - bx) + by >= yj && k3 * (xj-ax) + ay <= yj
          pset(xj,yj,r,g,b,t)
          end
        end

    end
    else

      axi.step(bxi-1) do |xi|
        200.times do |yi|
          if k1 * (xi - ax) + ay <= yi && k3 * (xi-ax) + ay >= yi
          pset(xi,yi,r,g,b,t)
          end

      end
    end

      bxi.step(cxi) do |xj|
        200.times do |yj|
          if k2 * (xj - bx) + by <= yj && k3 * (xj-ax) + ay >= yj
          pset(xj,yj,r,g,b,t)
          end
        end

    end  
  end
end

##############
#この先　演習4#
##############
def fillcirclequarter(x0, y0, rad1, rad2, r, g, b)
  200.times do |y|
    300.times do |x|
      if (x-x0)**2 + (y-y0)**2 <= rad**2 && x**2 +y**2 >= rad**2 && x>=x0 &&y >=y0
        pset(x, y, r, g, b,t)
      end
    end
  end
end

def fillcblur(x0, y0, rad, r, g, b)
    200.times do |y|
      300.times do |x|
        if (x-x0)**2 + (y-y0)**2 <= rad **2
          pset(x, y, r, g, b, (1.0-( (x-x0)**2 + (y-y0)**2)/rad**2 )))
        end
      end
    end
  end
end



